Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| org.openide.explorer 6.5.22 1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.openide.explorer.view
Class TreeTableView

    java.lang.Object
      java.awt.Component
          java.awt.Container
              javax.swing.JComponent
                  javax.swing.JScrollPane
                      org.openide.explorer.view.TreeView
                          org.openide.explorer.view.BeanTreeView
                              org.openide.explorer.view.TreeTableView

All Implemented Interfaces:
  ImageObserver, MenuContainer, Serializable, Accessible, ScrollPaneConstants

    public class TreeTableView

extends BeanTreeView

Explorer view. Allows to view tree of nodes on the left and its properties in table on the right.

The main mechanism for setting what properties are displayed is `setProperties (Node.Property[])`. Pass this method an array of properties. These will act as a template, and properties of the displayed nodes which share the same name will be used in the columns of the table. You can customize behaviour of property columns using `Property.setValue (String parameter, Object value)`. For example, assume you have following array of properties:
`org.openide.nodes.Node.Property[] properties`
if you need second column to be initially invisible in TreeTableView, you should set its custom parameter:
`properties[1].setValue ("InvisibleInTreeTableView", Boolean.TRUE);`

Parameter name | Parameter type | Description
--- | --- | ---
InvisibleInTreeTableView | Boolean | This property column should be initially invisible (hidden).
ComparableColumnTTV | Boolean | This property column should be used for sorting.
SortingColumnTTV | Boolean | TreeTableView should be initially sorted by this property column.
DescendingOrderTTV | Boolean | If this parameter and `SortingColumnTTV` is set, TreeTableView should be initially sorted by this property columns in descending order.
OrderNumberTTV | Integer | If this parameter is set to `N`, this property column will be displayed as Nth column of table. If not set, column will be displayed in natural order.
TreeColumnTTV | Boolean | Identifies special property representing first (tree) column. To allow setting of `SortingColumnTTV, DescendingOrderTTV, ComparableColumnTTV` parameters also for first (tree) column, use this special parameter and add this property to Node.Property[] array before calling TreeTableView.setProperties (Node.Property[]).
ColumnMnemonicCharTTV | String | When set, this parameter contains the mnemonic character for column's display name (e.g. in Change Visible Columns dialog window). If not set, no mnemonic will be displayed.

Since:
  1.7
See Also:
  Serialized Form

Nested Class Summary

Nested classes/interfaces inherited from class javax.swing.JScrollPane
`JScrollPane.AccessibleJScrollPane, JScrollPane.ScrollBar`

Nested classes/interfaces inherited from class javax.swing.JComponent
`JComponent.AccessibleJComponent`

Nested classes/interfaces inherited from class java.awt.Container
`Container.AccessibleAWTContainer`

Nested classes/interfaces inherited from class java.awt.Component
`Component.AccessibleAWTComponent, Component.BltBufferStrategy, Component.FlipBufferStrategy`

Field Summary
`protected JTable` | `treeTable` The table

Fields inherited from class org.openide.explorer.view.TreeView
`tree`

Fields inherited from class javax.swing.JScrollPane
`columnHeader, horizontalScrollBar, horizontalScrollBarPolicy, lowerLeft, lowerRight, rowHeader, upperLeft, upperRight, verticalScrollBar, verticalScrollBarPolicy, viewport`

Fields inherited from class javax.swing.JComponent
`accessibleContext, listenerList, TOOL_TIP_TEXT_KEY, ui, UNDEFINED_CONDITION, WHEN_ANCESTOR_OF_FOCUSED_COMPONENT, WHEN_FOCUSED, WHEN_IN_FOCUSED_WINDOW`

Fields inherited from class java.awt.Component
`BOTTOM_ALIGNMENT, CENTER_ALIGNMENT, LEFT_ALIGNMENT, RIGHT_ALIGNMENT, TOP_ALIGNMENT`

Fields inherited from interface javax.swing.ScrollPaneConstants
`COLUMN_HEADER, HORIZONTAL_SCROLLBAR, HORIZONTAL_SCROLLBAR_ALWAYS, HORIZONTAL_SCROLLBAR_AS_NEEDED, HORIZONTAL_SCROLLBAR_NEVER, HORIZONTAL_SCROLLBAR_POLICY, LOWER_LEADING_CORNER, LOWER_LEFT_CORNER, LOWER_RIGHT_CORNER, LOWER_TRAILING_CORNER, ROW_HEADER, UPPER_LEADING_CORNER, UPPER_LEFT_CORNER, UPPER_RIGHT_CORNER, UPPER_TRAILING_CORNER, VERTICAL_SCROLLBAR, VERTICAL_SCROLLBAR_ALWAYS, VERTICAL_SCROLLBAR_AS_NEEDED, VERTICAL_SCROLLBAR_NEVER, VERTICAL_SCROLLBAR_POLICY, VIEWPORT`

Fields inherited from interface java.awt.image.ImageObserver
`ABORT, ALLBITS, ERROR, FRAMEBITS, HEIGHT, PROPERTIES, SOMEBITS, WIDTH`

Constructor Summary
`TreeTableView()` Create TreeTableView with default NodeTableModel
`TreeTableView(NodeTableModel ntm)` Creates TreeTableView with provided NodeTableModel.

Method Summary
`void` | `addMouseListener(MouseListener l)`
`void` | `addNotify()` Initializes the component and lookup explorer manager.
`protected NodeTreeModel` | `createModel()` Create a new model.
`AccessibleContext` | `getAccessibleContext()` Overrides JScrollPane's getAccessibleContext() method to use internal accessible context.
`int` | `getTableAutoResizeMode()` Gets resize mode of table.
`int` | `getTableColumnPreferredWidth(int index)` Gets preferred width of table column
`int` | `getTreePreferredWidth()` Get preferred size of tree view
`void` | `removeMouseListener(MouseListener l)`
`void` | `removeNotify()` Deinitializes listeners.
`void` | `requestFocus()` Requests focus for the tree component.
`boolean` | `requestFocusInWindow()` Requests focus for the tree component.
`void` | `setDefaultActionAllowed(boolean value)` Enable/disable double click to invoke default action.
`void` | `setDragSource(boolean state)` Enables/disables dragging support.
`void` | `setDropTarget(boolean state)` Enables/disables dropping support.
`void` | `setHorizontalScrollBarPolicy(int policy)`
`void` | `setPopupAllowed(boolean value)` Enable/disable displaying popup menus on tree view items.
`void` | `setProperties(Node.Property[] props)` Set columns.
`void` | `setRowHeader(JViewport rowHeader)`
`void` | `setSelectionMode(int mode)` Sets the selection model, which must be one of TreeSelectionModel.SINGLE_TREE_SELECTION, TreeSelectionModel.CONTIGUOUS_TREE_SELECTION or TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION.
`void` | `setTableAutoResizeMode(int mode)` Sets resize mode of table.
`void` | `setTableColumnPreferredWidth(int index, int width)` Sets preferred width of table column
`void` | `setTreePreferredWidth(int width)` Set preferred size of tree view
`void` | `setVerticalScrollBarPolicy(int policy)`

Methods inherited from class org.openide.explorer.view.BeanTreeView
`isEnabled, selectionAccept, selectionChanged, setEnabled, showPath, showSelection`

Methods inherited from class org.openide.explorer.view.TreeView
`collapseNode, expandAll, expandNode, getAllowedDragActions, getAllowedDropActions, getBorder, getSelectionMode, isDefaultActionEnabled, isDragSource, isDropTarget, isExpanded, isPopupAllowed, isRootVisible, setAllowedDragActions, setAllowedDropActions, setRootVisible, updateUI, useExploredContextMenu`

Methods inherited from class javax.swing.JScrollPane
`createHorizontalScrollBar, createVerticalScrollBar, createViewport, getColumnHeader, getCorner, getHorizontalScrollBar, getHorizontalScrollBarPolicy, getRowHeader, getUI, getUIClassID, getVerticalScrollBar, getVerticalScrollBarPolicy, getViewport, getViewportBorder, getViewportBorderBounds, isValidateRoot, isWheelScrollingEnabled, paramString, setColumnHeader, setColumnHeaderView, setComponentOrientation, setCorner, setHorizontalScrollBar, setLayout, setRowHeaderView, setUI, setVerticalScrollBar, setViewport, setViewportBorder, setViewportView, setWheelScrollingEnabled`

Methods inherited from class javax.swing.JComponent
`addAncestorListener, addVetoableChangeListener, computeVisibleRect, contains, createToolTip, disable, enable, firePropertyChange, firePropertyChange, firePropertyChange, fireVetoableChange, getActionForKeyStroke, getActionMap, getAlignmentX, getAlignmentY, getAncestorListeners, getAutoscrolls, getBounds, getClientProperty, getComponentGraphics, getComponentPopupMenu, getConditionForKeyStroke, getDebugGraphicsOptions, getDefaultLocale, getFontMetrics, getGraphics, getHeight, getInheritsPopupMenu, getInputMap, getInputMap, getInputVerifier, getInsets, getInsets, getListeners, getLocation, getMaximumSize, getMinimumSize, getNextFocusableComponent, getPopupLocation, getPreferredSize, getRegisteredKeyStrokes, getRootPane, getSize, getToolTipLocation, getToolTipText, getToolTipText, getTopLevelAncestor, getTransferHandler, getVerifyInputWhenFocusTarget, getVetoableChangeListeners, getVisibleRect, getWidth, getX, getY, grabFocus, isDoubleBuffered, isLightweightComponent, isManagingFocus, isOpaque, isOptimizedDrawingEnabled, isPaintingTile, isRequestFocusEnabled, paint, paintBorder, paintChildren, paintComponent, paintImmediately, paintImmediately, print, printAll, printBorder, printChildren, printComponent, processComponentKeyEvent, processKeyBinding, processKeyEvent, processMouseEvent, processMouseMotionEvent, putClientProperty, registerKeyboardAction, registerKeyboardAction, removeAncestorListener, removeVetoableChangeListener, repaint, repaint, requestDefaultFocus, requestFocus, requestFocusInWindow, resetKeyboardActions, reshape, revalidate, scrollRectToVisible, setActionMap, setAlignmentX, setAlignmentY, setAutoscrolls, setBackground, setBorder, setComponentPopupMenu, setDebugGraphicsOptions, setDefaultLocale, setDoubleBuffered, setFocusTraversalKeys, setFont, setForeground, setInheritsPopupMenu, setInputMap, setInputVerifier, setMaximumSize, setMinimumSize, setNextFocusableComponent, setOpaque, setPreferredSize, setRequestFocusEnabled, setToolTipText, setTransferHandler, setUI, setVerifyInputWhenFocusTarget, setVisible, unregisterKeyboardAction, update`

Methods inherited from class java.awt.Container
`add, add, add, add, add, addContainerListener, addImpl, addPropertyChangeListener, addPropertyChangeListener, applyComponentOrientation, areFocusTraversalKeysSet, countComponents, deliverEvent, doLayout, findComponentAt, findComponentAt, getComponent, getComponentAt, getComponentAt, getComponentCount, getComponents, getComponentZOrder, getContainerListeners, getFocusTraversalKeys, getFocusTraversalPolicy, getLayout, getMousePosition, insets, invalidate, isAncestorOf, isFocusCycleRoot, isFocusCycleRoot, isFocusTraversalPolicyProvider, isFocusTraversalPolicySet, layout, list, list, locate, minimumSize, paintComponents, preferredSize, printComponents, processContainerEvent, processEvent, remove, remove, removeAll, removeContainerListener, setComponentZOrder, setFocusCycleRoot, setFocusTraversalPolicy, setFocusTraversalPolicyProvider, transferFocusBackward, transferFocusDownCycle, validate, validateTree`

Methods inherited from class java.awt.Component
`action, add, addComponentListener, addFocusListener, addHierarchyBoundsListener, addHierarchyListener, addInputMethodListener, addKeyListener, addMouseMotionListener, addMouseWheelListener, bounds, checkImage, checkImage, coalesceEvents, contains, createImage, createImage, createVolatileImage, createVolatileImage, disableEvents, dispatchEvent, enable, enableEvents, enableInputMethods, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, firePropertyChange, getBackground, getBounds, getColorModel, getComponentListeners, getComponentOrientation, getCursor, getDropTarget, getFocusCycleRootAncestor, getFocusListeners, getFocusTraversalKeysEnabled, getFont, getForeground, getGraphicsConfiguration, getHierarchyBoundsListeners, getHierarchyListeners, getIgnoreRepaint, getInputContext, getInputMethodListeners, getInputMethodRequests, getKeyListeners, getLocale, getLocation, getLocationOnScreen, getMouseListeners, getMouseMotionListeners, getMousePosition, getMouseWheelListeners, getName, getParent, getPeer, getPropertyChangeListeners, getPropertyChangeListeners, getSize, getToolkit, getTreeLock, gotFocus, handleEvent, hasFocus, hide, imageUpdate, inside, isBackgroundSet, isCursorSet, isDisplayable, isFocusable, isFocusOwner, isFocusTraversable, isFontSet, isForegroundSet, isLightweight, isMaximumSizeSet, isMinimumSizeSet, isPreferredSizeSet, isShowing, isValid, isVisible, keyDown, keyUp, list, list, list, location, lostFocus, mouseDown, mouseDrag, mouseEnter, mouseExit, mouseMove, mouseUp, move, nextFocus, paintAll, postEvent, prepareImage, prepareImage, processComponentEvent, processFocusEvent, processHierarchyBoundsEvent, processHierarchyEvent, processInputMethodEvent, processMouseWheelEvent, remove, removeComponentListener, removeFocusListener, removeHierarchyBoundsListener, removeHierarchyListener, removeInputMethodListener, removeKeyListener, removeMouseMotionListener, removeMouseWheelListener, removePropertyChangeListener, removePropertyChangeListener, repaint, repaint, repaint, resize, resize, setBounds, setBounds, setCursor, setDropTarget, setFocusable, setFocusTraversalKeysEnabled, setIgnoreRepaint, setLocale, setLocation, setLocation, setName, setSize, setSize, show, show, size, toString, transferFocus, transferFocusUpCycle`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### treeTable

    protected JTable treeTable

  The table

Constructor Detail

### TreeTableView

    public TreeTableView()

  Create TreeTableView with default NodeTableModel

### TreeTableView

    public TreeTableView(NodeTableModel ntm)

  Creates TreeTableView with provided NodeTableModel.

  Parameters:
    `ntm` - node table model

Method Detail

### setRowHeader

    public void setRowHeader(JViewport rowHeader)

  Overrides:
    `setRowHeader` in class `JScrollPane`

### setHorizontalScrollBarPolicy

    public void setHorizontalScrollBarPolicy(int policy)

  Overrides:
    `setHorizontalScrollBarPolicy` in class `JScrollPane`

### setVerticalScrollBarPolicy

    public void setVerticalScrollBarPolicy(int policy)

  Overrides:
    `setVerticalScrollBarPolicy` in class `JScrollPane`

### createModel

    protected NodeTreeModel createModel()

  Description copied from class: `BeanTreeView`
  Create a new model. The default implementation creates a `NodeTreeModel`.

  Overrides:
    `createModel` in class `BeanTreeView`
  Returns:
    the model

### requestFocus

    public void requestFocus()

  Requests focus for the tree component. Overrides superclass method.

  Overrides:
    `requestFocus` in class `TreeView`

### requestFocusInWindow

    public boolean requestFocusInWindow()

  Description copied from class: `TreeView`
  Requests focus for the tree component. Overrides superclass method.

  Overrides:
    `requestFocusInWindow` in class `TreeView`

### setSelectionMode

    public void setSelectionMode(int mode)

  Description copied from class: `TreeView`
  Sets the selection model, which must be one of TreeSelectionModel.SINGLE_TREE_SELECTION, TreeSelectionModel.CONTIGUOUS_TREE_SELECTION or TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION.

  This may change the selection if the current selection is not valid for the new mode. For example, if three TreePaths are selected when the mode is changed to `TreeSelectionModel.SINGLE_TREE_SELECTION`, only one TreePath will remain selected. It is up to the particular implementation to decide what TreePath remains selected. Note: TreeSelectionModel.DISCONTIGUOUS_TREE_SELECTION is set as default.

  Overrides:
    `setSelectionMode` in class `TreeView`
  Parameters:
    `mode` - selection mode

### getAccessibleContext

    public AccessibleContext getAccessibleContext()

  Overrides JScrollPane's getAccessibleContext() method to use internal accessible context.

  Specified by:
    `getAccessibleContext` in interface `Accessible`
  Overrides:
    `getAccessibleContext` in class `JScrollPane`

### setPopupAllowed

    public void setPopupAllowed(boolean value)

  Description copied from class: `TreeView`
  Enable/disable displaying popup menus on tree view items. Default is enabled.

  Overrides:
    `setPopupAllowed` in class `TreeView`
  Parameters:
    `value` - `true` to enable

### setDefaultActionAllowed

    public void setDefaultActionAllowed(boolean value)

  Description copied from class: `TreeView`
  Enable/disable double click to invoke default action. If defaultAction is not enabled double click expand/collapse node.

  Overrides:
    `setDefaultActionAllowed` in class `TreeView`
  Parameters:
    `value` - `true` to enable

### setProperties

    public void setProperties(Node.Property[] props)

  Set columns.

  Parameters:
    `props` - each column is constructed from Node.Property

### setTableAutoResizeMode

    public final void setTableAutoResizeMode(int mode)

  Sets resize mode of table.

  Parameters:
    `mode` - - One of 5 legal values:

        JTable.AUTO_RESIZE_OFF,
                                                   JTable.AUTO_RESIZE_NEXT_COLUMN,
                                                   JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS,
                                                   JTable.AUTO_RESIZE_LAST_COLUMN,
                                                   JTable.AUTO_RESIZE_ALL_COLUMNS

### getTableAutoResizeMode

    public final int getTableAutoResizeMode()

  Gets resize mode of table.

  Returns:
    mode - One of 5 legal values:

        JTable.AUTO_RESIZE_OFF,
                                                   JTable.AUTO_RESIZE_NEXT_COLUMN,
                                                   JTable.AUTO_RESIZE_SUBSEQUENT_COLUMNS,
                                                   JTable.AUTO_RESIZE_LAST_COLUMN,
                                                   JTable.AUTO_RESIZE_ALL_COLUMNS

### setTableColumnPreferredWidth

    public final void setTableColumnPreferredWidth(int index,
                                                   int width)

  Sets preferred width of table column

  Parameters:
    `index` - column index
    `width` - preferred column width

### getTableColumnPreferredWidth

    public final int getTableColumnPreferredWidth(int index)

  Gets preferred width of table column

  Parameters:
    `index` - column index
  Returns:
    preferred column width

### setTreePreferredWidth

    public final void setTreePreferredWidth(int width)

  Set preferred size of tree view

  Parameters:
    `width` - preferred width of tree view

### getTreePreferredWidth

    public final int getTreePreferredWidth()

  Get preferred size of tree view

  Returns:
    preferred width of tree view

### addNotify

    public void addNotify()

  Description copied from class: `TreeView`
  Initializes the component and lookup explorer manager.

  Overrides:
    `addNotify` in class `TreeView`

### removeNotify

    public void removeNotify()

  Description copied from class: `TreeView`
  Deinitializes listeners.

  Overrides:
    `removeNotify` in class `TreeView`

### addMouseListener

    public void addMouseListener(MouseListener l)

  Overrides:
    `addMouseListener` in class `Component`

### removeMouseListener

    public void removeMouseListener(MouseListener l)

  Overrides:
    `removeMouseListener` in class `Component`

### setDragSource

    public void setDragSource(boolean state)

  Description copied from class: `TreeView`
  Enables/disables dragging support.

  Overrides:
    `setDragSource` in class `TreeView`
  Parameters:
    `state` - true enables dragging support, false disables it.

### setDropTarget

    public void setDropTarget(boolean state)

  Description copied from class: `TreeView`
  Enables/disables dropping support.

  Overrides:
    `setDropTarget` in class `TreeView`
  Parameters:
    `state` - true means drops into view are allowed, false forbids any drops into this view.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| org.openide.explorer 6.5.22 1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Built on December 7 2006. | Portions Copyright 1997-2005 Sun Microsystems, Inc. All rights reserved.